var idEstudio;

$(document).ready(
	function() {
		inicial();
	}
);

function inicial(){
	limpiarTabla();
	realizaConsulta();
	inicializarBotones();
	$("table thead tr").addClass("encabezado");
}

function limpiarTabla(){	
	$('#divTablaIn').remove();
	var div = '<div id="divTablaIn"></div>';
	$('#divTablaExt').append(div);
	var tabla = $("<table class='table table-striped'/>").attr('id',"cataEstudio");       
	$("#divTablaIn").append(tabla);	
}

function realizaConsulta(){				
    // Obtener número de menú
    var menu = $("#pmn").val();
    var menuRegreso = $("#pmnReturn").val();
    var namespace = "/catalogos/categorias/";
    var rowId = null;
    var oTable = null;
    
    oTable = $('#cataEstudio').DataTable({		    
        autoWidth: false,
        language: {	
            processing: "Procesando...",
            lengthMenu: "Mostrar _MENU_ registros",
            zeroRecords: "Sin eventos encontrados",
            emptyTable: "Sin eventos encontrados",
            info: "Mostrando _START_ al _END_ de _TOTAL_",
            infoEmpty: "0 registros",
            infoFiltered: "(filtrado de un total de _MAX_ registros)",
            search: "Buscar:",
            thousands: ",",
            loadingRecords: "Cargando...",
            paginate: {
                first: "Primero",
                last: "&Uacute;ltimo",
                next: "Siguiente",
                previous: "Anterior"
            }
        },
        pageLength: 10,
        info: false,
        filter: true,
        ordering: false,
        paging: true,
        pagingType: "full_numbers",
        order: [],
        ajax: {
            url: "listadoCategorias",
            dataSrc: ""
        },
        columns: [
            { title: "Nombre", data: "nombre", searchable: true, width: "100px" },
            { title: "Accion", data: "nombre", searchable: true, width: "30px" }
        ],
        rowCallback: function(row, data, index) {
            var link = '<a onClick="actualizaCategorias(' + data["idCategoria"] + ')" data-bs-toggle="modal" data-bs-target="#modalAgregaActualiza">' + data["nombre"] + '</a>';
            var button = '<button class="btn btn-danger" type="button" onclick="eliminar(' + data["idCategoria"] + ')">Eliminar</button>';
            $(row).attr("id", data["idCategoria"]);
            $('td:eq(0)', row).html(link);
            $('td:eq(1)', row).html(button);
        }
    });
}


function validarAgregar(){
	
	$("#forma").validate(
		      {
		        rules: 
		        {
		        	nombreEstudio: 
		          {
		            required: true,
		            maxlength: 50,
		            regex:"^[a-zA-Z0-9 ]+$"
		          }
		        },
		        messages: 
		        {
		        	nombreEstudio: 
		          {
		            required: "Nombre del Estudio es obligatorio.",
		            maxlength: "Nombre no debe exceder 50 caracteres",
		            regex: "Nombre debe ser con caracteres alfanumericos"
		          }
		        }
	});
	
	$.validator.addMethod("regex",function(value,element,regexp){
	      var re= new RegExp(regexp);
	      return this.optional(element) || re.test(value);
	},"Only Characters from A-z");
}

function eliminar(id){
	if(confirm('¿Esta seguro de borrar este registro?')){
		var jsonString = '{"idCategoria" : "' + id + '"}';
		var stringJson = JSON.parse(jsonString);
		callActionAjax("/catalogos/categorias/eliminaCategoria", stringJson, procesaRespuestaActualiza);
	}
}

function inicializarBotones(){
	$("#nuevo").click(function()  
	{		
		window.location.href = contextPath + "/catalogos/categorias/dirigirAgregarCategoria.action?pmn=212&pmnReturn=212";				
	});
}

function regreso(){	
	var menu = $("#pmn").val();
	if(menu == '' || menu == null || menu == undefined)
		menu = 212;
	window.location.href = contextPath + "/catalogos/categorias/index.action?pmn=" + menu;
}

function actualizaCategorias(idCategori) {	
	$('#inpCategoria').val('');
	idCategoria = idCategori;
	llamaObtenCategorias(idCategoria);
}

function llamaObtenCategorias(idCategoria) {
	var jsonString = '{"idCategoria" : "'+ idCategoria +'"}';
	var stringJson = JSON.parse(jsonString);
	callActionAjax( "/catalogos/categorias/llamaObtenCategorias", stringJson, procesaRespuestaObtenCategoria);
}

function procesaRespuestaObtenCategoria(jsonData) {
	var est = jsonData.categoria;
	//debugger
	$('#inpCategoria').val(est.nombre);
}

function llamaActualizaCategoria() {
	var nombre = $('#inpCategoria').val();
	var jsonString = '{"idCategoria" : "'+ idCategoria + '", "nombreCategoria" : "' + nombre  +'"}';	
	var stringJson = JSON.parse(jsonString);
	callActionAjax( "/catalogos/categorias/llamaActualizaCategoria", stringJson, procesaRespuestaActualiza);

}

function procesaRespuestaActualiza(jsonData) {
	
	var seRepite = jsonData.seRepiteSigla;
	
	$('#modalAgregaActualiza').modal('hide');
	
	if(!seRepite) {
		showMessage("Actualizado con \u00E9xito");
	}else {
		showError("La sigla se repite en otro Estudio.");
	}
	
	inicial();	
}

function callActionAjax(actionRoute, jsonActionParameter, functionProcessor){
	 $.ajax({
	     url: contextPath + actionRoute,
	     type: 'POST',
	     data:  jsonActionParameter, 
		 dataType: "json",
	     success:function(response){ 
	    	 functionProcessor(response);    
	     },
	     error:function(jqXhr, textStatus, errorThrown){
	         showError("Problemas al enviar los datos.");
	     }
	 });	
}